import { resolveComponent as h, openBlock as i, createElementBlock as d, createBlock as n, createCommentVNode as u, Fragment as g, renderList as m, toDisplayString as c } from "vue";
import { _ as f } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
const v = {
  props: {
    modelValue: {
      type: [Number, String],
      default: 1
    },
    itemsPerPage: {
      type: Number,
      default: 10
    },
    totalPages: {
      type: Number,
      required: !0
    },
    maxVisiblePages: {
      type: Number,
      default: 5,
      validator: (a) => a % 2 === 1
    },
    showArrows: {
      type: Boolean,
      default: !0
    },
    showInfo: {
      type: Boolean,
      default: !0
    },
    loading: {
      type: Boolean,
      default: !1
    }
  },
  computed: {
    parsedModelValue() {
      return parseInt(this.modelValue, 10);
    },
    visiblePages() {
      const a = (this.maxVisiblePages - 1) / 2, s = [];
      return this.totalPages <= this.maxVisiblePages ? Array.from(Array(this.totalPages)).forEach((e, l) => {
        s.push(l + 1);
      }) : this.parsedModelValue <= a ? Array.from(Array(this.maxVisiblePages)).forEach((e, l) => {
        s.push(l + 1);
      }) : this.parsedModelValue > a && this.parsedModelValue < this.totalPages - a ? (Array.from(Array(a)).forEach((e, l) => {
        s.push(this.parsedModelValue - (l + 1));
      }), s.push(this.parsedModelValue), Array.from(Array(a)).forEach((e, l) => {
        s.push(this.parsedModelValue + (l + 1));
      })) : Array.from(Array(this.maxVisiblePages)).forEach((e, l) => {
        s.push(this.totalPages - l);
      }), s.sort((e, l) => e - l);
    },
    hasOverflow() {
      const a = this.visiblePages.includes(this.totalPages - 1);
      return this.totalPages - this.visiblePages.length > 1 && !a;
    }
  },
  emits: ["update:modelValue"],
  methods: {
    onClick(a) {
      this.$emit("update:modelValue", a);
    },
    onClickPrev() {
      this.$emit("update:modelValue", this.parsedModelValue - 1);
    },
    onClickNext() {
      this.$emit("update:modelValue", this.parsedModelValue + 1);
    }
  }
}, _ = { class: "lv-pagination" }, b = {
  key: 2,
  class: "lv-pagination__info"
};
function V(a, s, e, l, P, t) {
  const r = h("lv-button");
  return i(), d("div", _, [
    e.showArrows ? (i(), n(r, {
      key: 0,
      icon: "chevron-left",
      color: "ghost-default",
      disabled: t.parsedModelValue === 1 || e.loading,
      onClick: t.onClickPrev,
      class: "lv-pagination__button"
    }, null, 8, ["disabled", "onClick"])) : u("", !0),
    (i(!0), d(g, null, m(t.visiblePages, (o) => (i(), n(r, {
      key: o,
      label: o.toString(),
      color: o === t.parsedModelValue ? "solid-primary" : "ghost-default",
      onClick: (y) => t.onClick(o),
      class: "lv-pagination__button",
      loading: o === t.parsedModelValue && e.loading,
      disabled: o !== t.parsedModelValue && e.loading
    }, null, 8, ["label", "color", "onClick", "loading", "disabled"]))), 128)),
    e.showArrows ? (i(), n(r, {
      key: 1,
      icon: "chevron-right",
      color: "ghost-default",
      disabled: t.parsedModelValue === e.totalPages || e.loading,
      onClick: t.onClickNext,
      class: "lv-pagination__button"
    }, null, 8, ["disabled", "onClick"])) : u("", !0),
    e.showInfo ? (i(), d("div", b, c(t.parsedModelValue) + "/" + c(e.totalPages), 1)) : u("", !0)
  ]);
}
const M = /* @__PURE__ */ f(v, [["render", V]]);
export {
  M as default
};
