import { o as K } from "./index.104c9c16.mjs";
import { p as B } from "./propSizeMixin.5222687c.mjs";
import { resolveComponent as v, openBlock as o, createElementBlock as n, normalizeClass as C, withKeys as y, withModifiers as S, createBlock as h, createCommentVNode as b, renderSlot as r, createElementVNode as V, createTextVNode as p, toDisplayString as d, withDirectives as _, vModelText as k, Fragment as x, renderList as O, createVNode as L, Transition as E, withCtx as w, vShow as N } from "vue";
import { _ as g } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import "./index.673e51a0.mjs";
const j = {
  props: {
    option: {
      type: Object,
      required: !0
    },
    checkbox: {
      type: Boolean,
      default: !1
    },
    selected: {
      type: Boolean,
      default: !1
    },
    visible: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["click"],
  computed: {
    classObject() {
      return {
        "lv-select-option--selected": this.selected,
        "lv-select-option--has-checkbox": this.checkbox
      };
    }
  },
  methods: {
    onClickOption() {
      this.$emit("click", this.option);
    }
  }
};
function T(e, l, s, m, a, t) {
  const u = v("lv-checkbox");
  return s.visible ? (o(), n("div", {
    key: 0,
    class: C(["lv-select-option", t.classObject]),
    tabindex: "0",
    onClick: l[0] || (l[0] = (...c) => t.onClickOption && t.onClickOption(...c)),
    onKeydown: l[1] || (l[1] = y(S((...c) => t.onClickOption && t.onClickOption(...c), ["prevent"]), ["space", "enter"]))
  }, [
    s.checkbox ? (o(), h(u, {
      key: 0,
      tabindex: "-1",
      "model-value": s.selected,
      class: "lv-select-option__checkbox"
    }, null, 8, ["model-value"])) : b("", !0),
    r(e.$slots, "default")
  ], 34)) : b("", !0);
}
const z = /* @__PURE__ */ g(j, [["render", T]]);
const M = {
  components: {
    LvSelectOption: z
  },
  mixins: [B()],
  props: {
    modelValue: {
      type: [String, Number, Array],
      default: null
    },
    multiple: {
      type: Boolean,
      default: !1
    },
    searchable: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: (e) => e.searchable ? "Search an option" : "Choose an option"
    },
    clearable: {
      type: Boolean,
      default: !0
    },
    loading: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    teleportTarget: {
      type: String,
      default: "body"
    },
    options: {
      type: Array,
      default: () => []
    },
    optionValueKey: {
      type: String,
      default: "value"
    },
    optionLabelKey: {
      type: String,
      default: "label"
    }
  },
  emits: ["update:modelValue"],
  data() {
    return {
      dropdownVisible: !1,
      focusedOptionIndex: null,
      search: null
    };
  },
  computed: {
    searchedOptions() {
      return this.search ? this.options.filter(
        (e) => e[this.optionLabelKey].toLowerCase().includes(this.search.toLowerCase())
      ) : this.options;
    },
    selectedOption() {
      return this.multiple ? !1 : this.options.find((l) => l[this.optionValueKey] === this.modelValue) || !1;
    },
    selectedOptions() {
      return this.multiple ? this.options.filter((e) => this.modelValue.includes(e[this.optionValueKey])) : !1;
    },
    focusTrapOptions() {
      return {
        immediate: !0,
        escapeDeactivates: !1,
        fallbackFocus: document.body
      };
    },
    hasValue() {
      return !!(this.multiple && this.modelValue.length > 0 || !this.multiple && this.modelValue);
    },
    classObject() {
      return {
        [`lv-select--size-${this.size}`]: !0,
        "lv-select--disabled": !!this.disabled || !!this.loading,
        "lv-select--loading": !!this.loading
      };
    }
  },
  watch: {
    search(e) {
      !this.dropdownVisible && e && (this.dropdownVisible = !0);
    },
    value(e) {
      !this.multiple && this.dropdownVisible && (this.dropdownVisible = !1), e && this.search && (this.search = null);
    }
  },
  mounted() {
    K(this.$refs.select, () => {
      this.dropdownVisible = !1;
    });
  },
  methods: {
    onClickSelection() {
      this.dropdownVisible = !this.dropdownVisible;
    },
    onEscape() {
      this.dropdownVisible = !1;
    },
    onClickOption(e) {
      if (!this.multiple)
        this.modelValue === e[this.optionValueKey] && this.clearable ? this.$emit("update:modelValue", null) : (this.$emit("update:modelValue", e[this.optionValueKey]), this.dropdownVisible = !1);
      else if (this.multiple) {
        const l = [...this.modelValue];
        if (this.modelValue.includes(e[this.optionValueKey])) {
          const s = this.modelValue.findIndex(
            (m) => m === e[this.optionValueKey]
          );
          l.splice(s, 1), this.$emit("update:modelValue", l);
        } else
          l.push(e[this.optionValueKey]), this.$emit("update:modelValue", l);
      }
    },
    isSelected(e) {
      return !!(this.multiple && this.modelValue.includes(e[this.optionValueKey]) || !this.multiple && this.modelValue === e[this.optionValueKey]);
    }
  }
}, D = ["aria-expanded"], A = {
  key: 0,
  class: "lv-select__value"
}, F = ["placeholder"], I = {
  key: 2,
  class: "lv-select__placeholder"
}, U = {
  key: 1,
  class: "lv-select__value"
}, q = ["placeholder"], G = {
  key: 2,
  class: "lv-select__placeholder"
}, H = {
  class: "lv-select__dropdown",
  role: "listbox"
}, J = {
  key: 1,
  class: "lv-select__no-options"
}, P = /* @__PURE__ */ p(" No options found ");
function Q(e, l, s, m, a, t) {
  const u = v("lv-icon"), c = v("lv-select-option");
  return o(), n("div", {
    ref: "select",
    class: C(["lv-select", t.classObject]),
    role: "combobox",
    "aria-expanded": a.dropdownVisible,
    "aria-haspopup": "listbox",
    onKeydown: l[4] || (l[4] = y((...i) => t.onEscape && t.onEscape(...i), ["esc"]))
  }, [
    V("div", {
      ref: "combobox",
      class: "lv-select__input",
      tabindex: "0",
      onClick: l[2] || (l[2] = (...i) => t.onClickSelection && t.onClickSelection(...i)),
      onKeydown: l[3] || (l[3] = y(S((...i) => t.onClickSelection && t.onClickSelection(...i), ["prevent"]), ["enter", "space"]))
    }, [
      s.multiple ? s.multiple ? (o(), n("div", U, [
        t.hasValue ? (o(!0), n(x, { key: 0 }, O(t.selectedOptions, (i, f) => (o(), n("span", {
          key: f,
          class: "lv-select__value-item"
        }, [
          r(e.$slots, "value", { option: i }, () => [
            p(d(i[s.optionLabelKey]), 1)
          ])
        ]))), 128)) : s.searchable ? _((o(), n("input", {
          key: 1,
          "onUpdate:modelValue": l[1] || (l[1] = (i) => a.search = i),
          class: "lv-select__search",
          type: "text",
          placeholder: s.placeholder
        }, null, 8, q)), [
          [k, a.search]
        ]) : (o(), n("div", G, d(s.placeholder), 1))
      ])) : b("", !0) : (o(), n("div", A, [
        t.hasValue ? r(e.$slots, "value", {
          key: 0,
          option: t.selectedOption
        }, () => [
          p(d(t.selectedOption[s.optionLabelKey]), 1)
        ]) : s.searchable ? _((o(), n("input", {
          key: 1,
          "onUpdate:modelValue": l[0] || (l[0] = (i) => a.search = i),
          class: "lv-select__search",
          type: "text",
          placeholder: s.placeholder
        }, null, 8, F)), [
          [k, a.search]
        ]) : (o(), n("div", I, d(s.placeholder), 1))
      ])),
      s.loading ? (o(), h(u, {
        key: 2,
        class: "lv-select__loading",
        name: "loader-2"
      })) : (o(), h(u, {
        key: 3,
        class: "lv-select__icon",
        name: "chevron-down"
      }))
    ], 544),
    L(E, { name: "dropdown" }, {
      default: w(() => [
        _(V("div", H, [
          t.searchedOptions.length > 0 ? (o(!0), n(x, { key: 0 }, O(t.searchedOptions, (i, f) => (o(), h(c, {
            key: f,
            option: i,
            selected: t.isSelected(i),
            checkbox: !!s.multiple,
            onClick: t.onClickOption
          }, {
            default: w(() => [
              r(e.$slots, "option", { option: i }, () => [
                p(d(i.label), 1)
              ])
            ]),
            _: 2
          }, 1032, ["option", "selected", "checkbox", "onClick"]))), 128)) : (o(), n("div", J, [
            r(e.$slots, "no-options", {}, () => [
              P
            ])
          ]))
        ], 512), [
          [N, a.dropdownVisible]
        ])
      ]),
      _: 3
    })
  ], 42, D);
}
const $ = /* @__PURE__ */ g(M, [["render", Q]]);
export {
  $ as default
};
